/*
 * Copyright 2017 ETH Zuerich, CISD
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ch.ethz.sis.openbis.generic.asapi.v3.dto.sample.create;

import java.util.List;

import ch.ethz.sis.openbis.generic.asapi.v3.dto.entitytype.create.IEntityTypeCreation;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.plugin.id.IPluginId;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.property.create.PropertyAssignmentCreation;
import ch.systemsx.cisd.base.annotation.JsonObject;

/**
 * @author pkupczyk
 */
@JsonObject("as.dto.sample.create.SampleTypeCreation")
public class SampleTypeCreation implements IEntityTypeCreation
{

    private static final long serialVersionUID = 1L;

    private String code;

    private boolean autoGeneratedCode = false;

    private String generatedCodePrefix = "S";

    private boolean subcodeUnique = false;

    private String description;

    private boolean listable = true;

    private boolean showContainer = false;

    private boolean showParents = true;

    private boolean showParentMetadata = false;

    private IPluginId validationPluginId;

    private List<PropertyAssignmentCreation> propertyAssignments;

    @Override
    public String getCode()
    {
        return code;
    }

    @Override
    public void setCode(String code)
    {
        this.code = code;
    }

    public boolean isAutoGeneratedCode()
    {
        return autoGeneratedCode;
    }

    public void setAutoGeneratedCode(boolean autoGeneratedCode)
    {
        this.autoGeneratedCode = autoGeneratedCode;
    }

    public String getGeneratedCodePrefix()
    {
        return generatedCodePrefix;
    }

    public void setGeneratedCodePrefix(String generatedCodePrefix)
    {
        this.generatedCodePrefix = generatedCodePrefix;
    }

    public boolean isSubcodeUnique()
    {
        return subcodeUnique;
    }

    public void setSubcodeUnique(boolean subcodeUnique)
    {
        this.subcodeUnique = subcodeUnique;
    }

    @Override
    public String getDescription()
    {
        return description;
    }

    @Override
    public void setDescription(String description)
    {
        this.description = description;
    }

    public boolean isListable()
    {
        return listable;
    }

    public void setListable(boolean listable)
    {
        this.listable = listable;
    }

    public boolean isShowContainer()
    {
        return showContainer;
    }

    public void setShowContainer(boolean showContainer)
    {
        this.showContainer = showContainer;
    }

    public boolean isShowParents()
    {
        return showParents;
    }

    public void setShowParents(boolean showParents)
    {
        this.showParents = showParents;
    }

    public boolean isShowParentMetadata()
    {
        return showParentMetadata;
    }

    public void setShowParentMetadata(boolean showParentMetadata)
    {
        this.showParentMetadata = showParentMetadata;
    }

    @Override
    public IPluginId getValidationPluginId()
    {
        return validationPluginId;
    }

    @Override
    public void setValidationPluginId(IPluginId validationPluginId)
    {
        this.validationPluginId = validationPluginId;
    }

    @Override
    public List<PropertyAssignmentCreation> getPropertyAssignments()
    {
        return propertyAssignments;
    }

    @Override
    public void setPropertyAssignments(List<PropertyAssignmentCreation> propertyAssignments)
    {
        this.propertyAssignments = propertyAssignments;
    }

}
